# This file is part of Sympathy for Data.
# Copyright (c) 2013 System Engineering Software Society
#
# Sympathy for Data is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Sympathy for Data is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Sympathy for Data.  If not, see <http://www.gnu.org/licenses/>.
"""The flow module."""

from .node import node_factory, Node
from .flow import Flow
from .functions import Lambda, Map, Apply
from .port import Port
from .textfield import TextField
from .flowio import FlowInput, FlowOutput
from .types import NodeInterface, Type, Executors
from .connection import Connection, connection_direction


__all__ = ['node_factory', 'Node', 'Flow', 'Lambda', 'Map', 'Apply', 'Port',
           'TextField', 'FlowInput', 'FlowOutput', 'NodeInterface', 'Type',
           'Executors', 'Connection', 'connection_direction']
